commit 42800be8ef2daeeb921d32691126dad3ac297f38
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Tue Nov 1 23:50:57 2011 +0200

    Added File/Container properties windows
    Added ShowProperties command
    Container properties menu doesn't appear,even though the properties work
    Problem with automatic authentication

diff --git a/trunk/Pithos.ShellExtensions/Service References/PithosService/configuration.svcinfo b/trunk/Pithos.ShellExtensions/Service References/PithosService/configuration.svcinfo
index 13dae7e..ce5aeab 100644
--- a/trunk/Pithos.ShellExtensions/Service References/PithosService/configuration.svcinfo	
+++ b/trunk/Pithos.ShellExtensions/Service References/PithosService/configuration.svcinfo	
@@ -4,9 +4,11 @@
   <bindings>
     <binding digest="System.ServiceModel.Configuration.NetNamedPipeBindingElement, System.ServiceModel, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089:&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data hostNameComparisonMode=&quot;StrongWildcard&quot; maxBufferSize=&quot;65536&quot; maxConnections=&quot;10&quot; name=&quot;NetNamedPipeBinding_IStatusService&quot; transactionFlow=&quot;false&quot; transactionProtocol=&quot;OleTransactions&quot; transferMode=&quot;Buffered&quot;&gt;&lt;readerQuotas maxArrayLength=&quot;16384&quot; maxBytesPerRead=&quot;4096&quot; maxDepth=&quot;32&quot; maxNameTableCharCount=&quot;16384&quot; maxStringContentLength=&quot;8192&quot; /&gt;&lt;security mode=&quot;None&quot;&gt;&lt;transport protectionLevel=&quot;EncryptAndSign&quot; /&gt;&lt;/security&gt;&lt;/Data&gt;" bindingType="netNamedPipeBinding" name="NetNamedPipeBinding_IStatusService" />
     <binding digest="System.ServiceModel.Configuration.NetNamedPipeBindingElement, System.ServiceModel, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089:&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data hostNameComparisonMode=&quot;StrongWildcard&quot; maxBufferSize=&quot;65536&quot; maxConnections=&quot;10&quot; name=&quot;NetNamedPipeBinding_ISettingsService&quot; transactionFlow=&quot;false&quot; transactionProtocol=&quot;OleTransactions&quot; transferMode=&quot;Buffered&quot;&gt;&lt;readerQuotas maxArrayLength=&quot;16384&quot; maxBytesPerRead=&quot;4096&quot; maxDepth=&quot;32&quot; maxNameTableCharCount=&quot;16384&quot; maxStringContentLength=&quot;8192&quot; /&gt;&lt;security mode=&quot;None&quot;&gt;&lt;transport protectionLevel=&quot;EncryptAndSign&quot; /&gt;&lt;/security&gt;&lt;/Data&gt;" bindingType="netNamedPipeBinding" name="NetNamedPipeBinding_ISettingsService" />
+    <binding digest="System.ServiceModel.Configuration.NetNamedPipeBindingElement, System.ServiceModel, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089:&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data hostNameComparisonMode=&quot;StrongWildcard&quot; maxBufferSize=&quot;65536&quot; maxConnections=&quot;10&quot; name=&quot;NetNamedPipeBinding_ICommandsService&quot; transactionFlow=&quot;false&quot; transactionProtocol=&quot;OleTransactions&quot; transferMode=&quot;Buffered&quot;&gt;&lt;readerQuotas maxArrayLength=&quot;16384&quot; maxBytesPerRead=&quot;4096&quot; maxDepth=&quot;32&quot; maxNameTableCharCount=&quot;16384&quot; maxStringContentLength=&quot;8192&quot; /&gt;&lt;security mode=&quot;None&quot;&gt;&lt;transport protectionLevel=&quot;EncryptAndSign&quot; /&gt;&lt;/security&gt;&lt;/Data&gt;" bindingType="netNamedPipeBinding" name="NetNamedPipeBinding_ICommandsService" />
   </bindings>
   <endpoints>
     <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/statuscache&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_IStatusService&quot; contract=&quot;PithosService.IStatusService&quot; name=&quot;NetNamedPipeBinding_IStatusService&quot; /&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/statuscache&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_IStatusService&quot; contract=&quot;PithosService.IStatusService&quot; name=&quot;NetNamedPipeBinding_IStatusService&quot; /&gt;" contractName="PithosService.IStatusService" name="NetNamedPipeBinding_IStatusService" />
     <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/settings&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_ISettingsService&quot; contract=&quot;PithosService.ISettingsService&quot; name=&quot;NetNamedPipeBinding_ISettingsService&quot; /&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/settings&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_ISettingsService&quot; contract=&quot;PithosService.ISettingsService&quot; name=&quot;NetNamedPipeBinding_ISettingsService&quot; /&gt;" contractName="PithosService.ISettingsService" name="NetNamedPipeBinding_ISettingsService" />
+    <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/commands&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_ICommandsService&quot; contract=&quot;PithosService.ICommandsService&quot; name=&quot;NetNamedPipeBinding_ICommandsService&quot; /&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.pipe://localhost/pithos/commands&quot; binding=&quot;netNamedPipeBinding&quot; bindingConfiguration=&quot;NetNamedPipeBinding_ICommandsService&quot; contract=&quot;PithosService.ICommandsService&quot; name=&quot;NetNamedPipeBinding_ICommandsService&quot; /&gt;" contractName="PithosService.ICommandsService" name="NetNamedPipeBinding_ICommandsService" />
   </endpoints>
 </configurationSnapshot>
\ No newline at end of file