commit 65814c28678b2d598f3d035bf7252662a2b12ad6
Author: Olga Brani <olgabrani@grnet.gr>
Date:   Wed Aug 28 16:34:37 2013 +0300

    new ui: responsive design for entities list pages

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/pithos_list.html b/snf-cyclades-app/synnefo/ui/new_ui/ui/pithos_list.html
index 271dec1..c7707e0 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/pithos_list.html
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/pithos_list.html
@@ -88,166 +88,167 @@
 			</div>
 
 		</div>
-		
-		<!-- sidebar -->
-		<div class="lt-sidebar">
-			 <nav class="sidenav">
-			 	<ul>
-			 		<li><a href="">trash</a><span>></span></li>
-			 		<li><a href="">shared with me</a><span>></span></li>
-			 		<li><a href="">shared by me</a><span>></span></li>
-			 		<li><a href="">groups</a><span>></span></li>
-			 	</ul>
-			 </nav>
-			 <form action="" method="">
-			 	<input type="text" placeholder="search">
-			 </form>
-		</div>
+		<div class="onecol">
+			<!-- sidebar -->
+			<div class="lt-sidebar">
+				 <nav class="sidenav">
+				 	<ul>
+				 		<li><a href="">trash</a><span>></span></li>
+				 		<li><a href="">shared with me</a><span>></span></li>
+				 		<li><a href="">shared by me</a><span>></span></li>
+				 		<li><a href="">groups</a><span>></span></li>
+				 	</ul>
+				 </nav>
+				 <form action="" method="">
+				 	<input type="text" placeholder="search">
+				 </form>
+			</div>
 
-		<div class="main content">
-			
+			<div class="main content">
+				
 
-		<div class="confirmation"></div>
-			<ul class="breadcrumbs">
-				<li><a href="">shared by me</a></li>
-				<li><a href="">folder 1</a></li>
-				<li>folder 2</li>
-			</ul>
-			<ul class="files">
-				<li class="titles">
-					<div class="name-col">name</div>
-					<div class="size-col">size</div>
-					<div class="date-col">last modified</div>
-					<div class="actions-col">&nbsp;</div>
-				</li>
-				<li>
-					<div class="name-col folder" data-tooltip class="has-tip" title="metadata or info (ex. contains 3 files)">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col folder">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 4:23 pm</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col txt"  data-tooltip class="has-tip" title="metadata or info (ex. has been modified 3 times)">file1.txt</div>
-					<div class="size-col">5MB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col pdf">mypdfile.pdf</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col folder">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col txt">file1.txt</div>
-					<div class="size-col">5MB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col pdf">mypdfile.pdf</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col folder">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col txt">file1.txt</div>
-					<div class="size-col">5MB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col pdf">mypdfile.pdf</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col folder">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col txt">file1.txt</div>
-					<div class="size-col">5MB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col pdf">mypdfile.pdf</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12 6:23 am</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-				<li>
-					<div class="name-col folder">folder1</div>
-					<div class="size-col">123KB</div>
-					<div class="date-col">23/12/12</div>
-					<div class="actions-col">
-						<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
-						<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
-					</div>
-				</li>
-			</ul>
+			<div class="confirmation"></div>
+				<ul class="breadcrumbs">
+					<li><a href="">shared by me</a></li>
+					<li><a href="">folder 1</a></li>
+					<li>folder 2</li>
+				</ul>
+				<ul class="files">
+					<li class="titles">
+						<div class="name-col">name</div>
+						<div class="size-col">size</div>
+						<div class="date-col">last modified</div>
+						<div class="actions-col">&nbsp;</div>
+					</li>
+					<li>
+						<div class="name-col folder" data-tooltip class="has-tip" title="metadata or info (ex. contains 3 files)">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col folder">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 4:23 pm</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col txt"  data-tooltip class="has-tip" title="metadata or info (ex. has been modified 3 times)">file1.txt</div>
+						<div class="size-col">5MB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col pdf">mypdfile.pdf</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col folder">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col txt">file1.txt</div>
+						<div class="size-col">5MB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col pdf">mypdfile.pdf</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col folder">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col txt">file1.txt</div>
+						<div class="size-col">5MB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col pdf">mypdfile.pdf</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col folder">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col txt">file1.txt</div>
+						<div class="size-col">5MB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col pdf">mypdfile.pdf</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12 6:23 am</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+					<li>
+						<div class="name-col folder">folder1</div>
+						<div class="size-col">123KB</div>
+						<div class="date-col">23/12/12</div>
+						<div class="actions-col">
+							<a href="" class="delete" data-tooltip class="has-tip" title="Delete"><span class="snf-font">n</span></a>
+							<a href="" class="copy"  data-tooltip class="has-tip" title="Copy"><span class="snf-font">q</span></a>
+						</div>
+					</li>
+				</ul>
 
+			</div>
 		</div>
 		<div class="progress-bar">
 			<span class="counter">6 files uploading</span>